import h5py as h5
import numpy as np
import matplotlib.pyplot as plt
import numpy.ma as ma
import matplotlib as mpl
import seaborn as sns
from mpl_toolkits.axes_grid1.inset_locator import zoomed_inset_axes
from mpl_toolkits.axes_grid1.inset_locator import mark_inset

from scipy.interpolate import griddata
import scipy.spatial as spatial
import scipy.linalg as linalg
import scipy.sparse as sparse

"""
The functions here plot the figures that appear in ICCS paper.
It's assumed we already have the .h5 files required (generated by the .cpp scripts)
"""

#Latex font size is 12 pts
plt.rcParams.update({
    "mathtext.fontset": "cm",
    "font.family": "STIXGeneral",
    "text.usetex": False,
    "axes.formatter.use_mathtext": True,
    "font.size" : 12,
    "pgf.preamble": r"\usepackage{siunitx}",
})
#print(sns.color_palette("colorblind"))

#mpl.rcParams['axes.prop_cycle'] = mpl.cycler(color=["#0072B2", "#009E73", "#D55E00", "#CC79A7","#F0E442", "#56B4E9"])
ccycle = mpl.rcParams['axes.prop_cycle'].by_key()['color']
#ccycle = mpl.rcParams['axes.prop_cycle']
#mpl.rcParams['axes.prop_cycle'] = mpl.cycler(color=["blue", "red", "orange", "green", "purple", "brown"]) 

dpitoUse = 400

def getContent(filename):
    """Helper function to transform .h5 file into a dict"""
    
    f = h5.File(filename)
    res = {}
    for key in f.keys():
        res[key] = f[key][:]
    f.close()
    return res

def f(x,y,lap=False):
    """Return test function (sinx siny) value and derivative"""
    
    if (lap):
        return -2*np.pi*np.pi*f(x,y)
    else:
        return np.sin(np.pi*x)*np.sin(np.pi*y)

def bndBall(xx,yy):
    """Returns true if x,y are boundary points of the domain"""
    x = xx-0.5
    y = yy-0.5
    if abs(x*x+y*y-0.5*0.5)<1e-8:
        return True
    return False

bndBallVec = np.vectorize(bndBall)


def addArrow(fig, ax1, ax2, xyA, xyB):
    """Helper function to draw an arrow between subplots"""
    
    transFigure = fig.transFigure.inverted()
    line = mpl.patches.ConnectionPatch(
        xyA,  # xdata
        xyB,  # ydata
        coordsA=ax1.transData,
        coordsB=ax2.transData,
        color="black",
        arrowstyle = "-|>",
        mutation_scale=20,
        linewidth=1,
    )
    fig.patches.append(line)

def adjustTickFont(*axes, labelsize=20):
    """Helper function to adjust tick font size easily"""
    
    for ax in axes:
        ax.tick_params(axis='both', which='major', labelsize=labelsize)
        ax.tick_params(axis='both', which='minor', labelsize=labelsize)

def obtainErrorBounds(fname,n,funk=f): #TODO bndball
    """Obtain min and max error for a given approximation"""
    
    d = getContent(fname)
    x, y = d['positions']
    real = [funk(xx,yy) for xx,yy, in zip(x,y)]
    u = d[f'SolutionN{n}']
    u = u-real
    return [np.amin(u),np.amax(u)]

def checkLaplaceErrors(fname, ax, aggFunk = np.amax, funk=None, numberMetric = False):
    """Produce an Error(support size) plot.
    fname - filename with results
    ax - to plot it on
    aggFunk - l_inf or l_2 error
    funk - real solution
    numberMetric - whether to plot error or our introduced metric
    """
    
    if funk is None:
        funk = lambda x,y : f(x,y,True)
    d = getContent(fname)
    x,y = d['positions']
    realVals = []
    toDelete = []
    for i in range(len(x)):
        realVals.append(funk(x[i],y[i]))
        if bndBall(x[i],y[i]):
            toDelete.append(i) #boundary node not included in averaging
    errors = []
    for n in d['support']:
        if numberMetric:
            error = d[f'derXSize{n}']-np.array(realVals)
            numPlus = len(error[error > 0])
            numMinus = len(error[error < 0])
            errors.append((numPlus-numMinus)/(numPlus+numMinus))
        else:
            error = np.abs(np.array(realVals)-d[f'derXSize{n}'])
            errors.append(aggFunk(np.delete(error,toDelete)))
    #errors = np.array(errors)
    #absmax = np.amax(np.abs(errors))
    #errors = errors/absmax
    ax.plot(d['support'],errors, ls="-", marker=".")
    if not numberMetric:
        ax.set_yscale("log")
    
    
def checkPoisson(filename, support, ax, funk=f, aggFunk = np.amax, numberMetric = False):
    """Produce an Error(support size) plot.
    
    fname - filename with results
    support - array of support sizes
    ax - the ax to plot on
    funk - real solution
    aggFunk - function to aggregate point  value errors in a single one
    numberMetric - whether to plot actual errors or just the inroduced metric
    """
    
    d = getContent(filename)
    x, y = d['positions']
    real = [funk(xx,yy) for xx,yy in zip(x,y)]
    absErrors = []
    for n in support:
        u = d[f'SolutionN{n}']
        if numberMetric:
            numPlus = len((u-real)[u-real > 0])
            numMinus = len((u-real)[u-real < 0])
            absErrors.append((numPlus-numMinus)/(numPlus+numMinus))
        else:
            absErrors.append(aggFunk(np.abs(real-u)))
    if not numberMetric:
        ax.set_yscale("log")
    return ax.plot(support,absErrors,ls="-", marker=".")



poissonErrors = [np.inf, -np.inf]
lapErrors = [np.inf, -np.inf]
 
    
def plotPoissonErrorContour(filename, n, ax, funk=f, vmin=-100,vmax=100, normalise=False, color="viridis"):
    """Plot the spatial dependence of Poisson Eq sol. error
    
    filename - filename with our approximations
    n - stencil size
    ax - to plot it on
    funk - real solution
    vmin - vmin to use in colorscale
    vmax - vmax to use in colorscale
    normalise - whether to normalise the errors to +-1
    color - cmap used (string)
    """
    
    d = getContent(filename)
    x, y = d['positions']
    real = [funk(xx,yy) for xx,yy in zip(x,y)]
    absErrors = []
    u =  d[f'SolutionN{n}'] - real
    if normalise:
        u = np.array([1 if i>=0 else -1 for i in u])
    maska = bndBallVec(x,y)
    x = ma.array(x, mask=maska)
    y = ma.array(y, mask=maska)
    u = ma.array(u, mask=maska)
    poissonErrors[0] = min(np.amin(u),poissonErrors[0]) 
    poissonErrors[1] = max(np.amax(u),poissonErrors[1])
    cmap=plt.get_cmap(color)
    norm = mpl.colors.SymLogNorm(1e-7, vmin=vmin, vmax=vmax) 
    #ax.scatter(x,y,c=u,s=0.1)
    ax.scatter(x,y,c=u,norm=norm,s=0.1, cmap=cmap)
    #ax.set_aspect(1)
    
def plotLapErrorContour(filename, n, ax, vmin=-100, vmax=100, normalise = False, color="magma"):
    """Plot the spatial dependence of Laplace Op. error
    
    filename - filename with our approximations
    n - stencil size
    ax - to plot it on
    vmin - vmin to use in colorscale
    vmax - vmax to use in colorscale
    normalise - whether to normalise the errors to +-1
    color - cmap used (string)
    """
    
    d = getContent(filename)
    x,y = d['positions']
    real = [f(xx,yy,True) for xx,yy in zip(x,y)]
    absErrors = []
    u = d[f'derXSize{n}'] - real
    if normalise:
        u = np.array([1 if i>=0 else -1 for i in u])
    maska = bndBallVec(x,y)
    x = ma.array(x, mask=maska)
    y = ma.array(y, mask=maska)
    u = ma.array(u, mask=maska)
    lapErrors[0] = min(np.amin(u), lapErrors[0])
    lapErrors[1] = max(np.amax(u), lapErrors[1])
    norm = mpl.colors.SymLogNorm(1e-7, vmin=vmin, vmax=vmax)
    ax.scatter(x,y,c=u,norm=norm, cmap=plt.get_cmap(color), s=0.1)
    #ax.scatter(x,y,c=u,norm=norm)
    #ax.set_aspect(1)


def plotSolutionSpecific2(fname,ax,color):
    """Plot the given solution
    fname - filename used for position nodes
    funk - the solution to be plotted
    ax - ax to plot on
    """
    
    d = getContent(fname)
    x, y = d['positions']

    sc = ax.scatter(x,y,s=0.05,c=color)

    axins = zoomed_inset_axes(ax,3,loc=1)
    axins.scatter(x,y,s=1,c=color)
    axins.set_xlim(0.1,0.25)
    axins.set_ylim(0.5,0.65)
    axins.set_xticks([])
    axins.set_yticks([])
    mark_inset(ax,axins,loc1=2,loc2=4)
    return sc

    
def plotSolutionSpecific(fname,funk, ax):
    """Plot the given solution
    fname - filename used for position nodes
    funk - the solution to be plotted
    ax - ax to plot on
    """
    
    d = getContent(fname)
    x, y = d['positions']
    real = [funk(xx,yy) for xx,yy in zip(x,y)]
    norm = mpl.colors.Normalize(vmin=np.amin(real),vmax=np.amax(real))
    sc = ax.scatter(x,y,c=real,norm=norm, cmap=plt.get_cmap("cividis"),s=1)
    return sc

def plotSolution():
    """Makes the Solution plot for the paper
    """
    sizehere=10
    mpl.rcParams.update({'font.size': sizehere})
    mpl.rcParams.update({'xtick.labelsize': sizehere})
    mpl.rcParams.update({'axes.labelsize': sizehere})
    mpl.rcParams.update({'ytick.labelsize': sizehere})

    fig, ax = plt.subplots()    
    sc = plotSolutionSpecific("Data/PoissonResultshFactor20.h5",f, ax)
    ax.set_xlabel("$x$")
    ax.set_ylabel("$y$")
    #adjustTickFont(ax,labelsize=18)
    ax.set_aspect(1)
    #ax.set_title(r"$u(x,y) = \sin (\pi x) \sin (\pi y)$")
    cb = fig.colorbar(sc, ax=ax, pad=0.005)
    cb.set_label(r"$u$")
    plt.tight_layout()
    plt.savefig("../FiguresPaper/Solution.png",dpi=dpitoUse, transparent = False,bbox_inches='tight')

def plotDiscretisation():
    """Makes discretisation/stencil plot for the paper
    """

    sizehere=16
    mpl.rcParams.update({'font.size': sizehere})
    mpl.rcParams.update({'xtick.labelsize': sizehere})
    mpl.rcParams.update({'axes.labelsize': sizehere})
    mpl.rcParams.update({'ytick.labelsize': sizehere})

    fig, ax = plt.subplots()
    d = getContent("Data/PoissonResultshFactor20.h5")
    x, y = d['positions']
    kdtree = spatial.KDTree(np.column_stack((x,y)))
    ax.scatter(x,y,s=1)
    locs = {25:[0,800],45:[210,1600]}
    lines = []
    for n in [25,45]:
        color = 'green' if n==25 else 'orange'
        for loc in locs[n]:
            stencil = kdtree.query([[x[loc],y[loc]]],k=n)[1]
            lines.append(ax.scatter(x[stencil],y[stencil],s=10,color=color,label=f"$n={n}$ stencil"))
            lines.append(ax.scatter([x[loc]],[y[loc]],s=100,color="red",marker="2",label = "Stencil center"))
    
    #legend1 = ax.legend([lines[0],lines[4],lines[-1]],[r"$n=25$",r"$n=45$","Stencil center"], loc=(0.5,0.7), framealpha=1, handletextpad=0.01)
    legend1 = ax.legend([lines[0],lines[4]],[r"$n=25$",r"$n=45$"], loc=(0.5,0.7), framealpha=1, handletextpad=0.01)

    for handle in legend1.legendHandles:
        handle.set_sizes([50.0])
    ax.legend([lines[-1]],["Stencil center"],loc=(0.25,0.02), handletextpad=0.1, framealpha=1)
    ax.add_artist(legend1)
    ax.set_xlabel("$x$")
    ax.set_ylabel("$y$")
    ax.set_aspect(1)
    plt.tight_layout()
    plt.savefig("../FiguresPaper/Discretisation.png",dpi=dpitoUse, transparent = False,bbox_inches='tight')
    
def plotGraphAndContours():
    """Plot the error and the 4 contours for paper"""

    defsize=14
    mpl.rcParams.update({'axes.titlesize' : 15})
    mpl.rcParams.update({'font.size': defsize})
    mpl.rcParams.update({'xtick.labelsize': defsize})
    mpl.rcParams.update({'legend.fontsize': defsize})
    mpl.rcParams.update({'axes.labelsize': defsize})
    mpl.rcParams.update({'ytick.labelsize': defsize})

    nsOfInterest = [17,28,34,46]
    fig = plt.figure(figsize=(8,4), constrained_layout=True)
    gs = fig.add_gridspec(2,17)
    ax = fig.add_subplot(gs[:,:8])
    ax.grid(True)
    ax.set_ylabel(r"$e_\mathrm{poiss}^\mathrm{max}$")
    ax.set_xlabel(r"$n$")
    checkPoisson("Data/PoissonResults.h5",list(range(10,70)),ax)
    xdata = ax.lines[0].get_xdata()
    ydata = ax.lines[0].get_ydata()

    vmin = np.inf
    vmax = -np.inf
    for n in nsOfInterest:
        vm = obtainErrorBounds("Data/PoissonResults.h5", n)
        vmin = min(vmin,vm[0])
        vmax = max(vmax,vm[1])
    ax1 = fig.add_subplot(gs[0,8:12])
    ax2 = fig.add_subplot(gs[0,12:16])
    ax3 = fig.add_subplot(gs[1,8:12])
    ax4 = fig.add_subplot(gs[1,12:16])
    axes = [ax1,ax2,ax3,ax4]
    colors = ccycle[1:1+4]
    for i in range(4):
        plotPoissonErrorContour("Data/PoissonResults.h5", nsOfInterest[i], axes[i],vmin=vmin,vmax=vmax)
        axes[i].get_xaxis().set_ticks([])
        axes[i].get_yaxis().set_ticks([])
        ax.plot([nsOfInterest[i]],[ydata[np.where(xdata == nsOfInterest[i])]],"o", color=colors[i])
        for side in axes[i].spines:
            axes[i].spines[side].set_color(colors[i])
        axes[i].set_title(f"$n={nsOfInterest[i]}$", color=colors[i])
        axes[i].set_aspect(1)
    
    #fig.subplots_adjust(right=0.8)
    #cbar_ax = fig.add_axes([0.85, 0.15, 0.05, 0.7])
    cbar_ax = fig.add_subplot(gs[:,16])
    norm = mpl.colors.SymLogNorm(1e-7, vmin=vmin, vmax=vmax)
    cb = mpl.colorbar.ColorbarBase(cbar_ax, cmap=plt.get_cmap("viridis"), norm=norm,orientation = 'vertical')
    cb.set_label(r"$e_\mathrm{poiss}^\pm$")
    #plt.margins(x=0,y=0)
    plt.savefig("../FiguresPaper/PlotWithContours.png", dpi=dpitoUse, transparent=False, bbox_inches='tight')


def plotConvergence():
    """Plot the graph showing the convergence"""
    mpl.rcParams.update({'font.size': 17})
    mpl.rcParams.update({'xtick.labelsize': 17})
    mpl.rcParams.update({'legend.fontsize': 17})
    mpl.rcParams.update({'axes.labelsize': 17})
    mpl.rcParams.update({'ytick.labelsize': 17})
    
    scales = [1,5,10,20,30,50][::-1]
    fnames = [f"Data/PoissonResultshFactor{s}.h5" for s in scales]
    fig, ax= plt.subplots(1,2,figsize=(10,4), constrained_layout=True,sharey=True)
    #fig, ax = plt.subplots(1,2,figsize=(7,4), constrained_layout=True, sharey=True)

    ydatas = []
    
    for s,fN in zip(scales,fnames):
        checkPoisson(fN,list(range(10,70)),ax[0])
        ax[0].lines[-1].set_label(f"$h={s*0.001}$")
        ydatas.append(ax[0].lines[-1].get_ydata())
    ydatas = np.array(ydatas)
    ax[0].set_ylabel(r"$e_\mathrm{poiss}^\mathrm{max}$")
    ax[0].set_xlabel(r"$n$")
    ax[0].set_yscale("log")
    hs = [0.001*s for s in scales]
    cmap = plt.get_cmap("Reds")
    colors = [cmap(s) for s in np.linspace(0.2,1,47-34)]
    for i,n in enumerate(range(34,47)):
        ax[1].plot(hs,ydatas[:,n-10], color=colors[i],marker=".")
        if n in [34,40,46]:
            ax[1].lines[-1].set_label(f"$n={n}$")
    ax[1].set_yscale("log")
    ax[1].set_xscale("log")
    ax[1].invert_xaxis()
    ax[1].set_xlabel(r"$h$")
    #ax[1].get_yaxis().set_visible(False)
    #ax[1].set_yticklabels([])

    #ax[0].set_ylim(4.9*1e-7,1e-3)
    #ax[1].set_ylim(4.9*1e-7,1e-3)
    ax[1].plot(hs,[6*h**2 for h in hs],ls="--",color="green")
    ax[1].text(0.015,0.002,r"$h^2$",color="green")
    ax[0].grid()
    ax[1].grid(which='both', axis='x')
    ax[1].grid(which='major', axis='y')
    ax[1].legend(loc="upper right")
    #ax[1].set_xticks([1e-2,4e-3,2e-3])
    #ax[1].set_xticks([],minor=True)

    ax[0].legend(loc="upper right", ncols=1, columnspacing=1, handlelength=1, handletextpad=0.1)

    plt.savefig("../FiguresPaper/Convergence.png", dpi=dpitoUse, transparent=False,bbox_inches='tight')
    
def plotBndFixed():
    defsize=20
    mpl.rcParams.update({'font.size': defsize})
    mpl.rcParams.update({'xtick.labelsize': defsize})
    mpl.rcParams.update({'legend.fontsize': defsize})
    mpl.rcParams.update({'axes.labelsize': defsize})
    mpl.rcParams.update({'ytick.labelsize': defsize})
    
    """Plot the graph showing the boundary (non)effect"""
    fig, ax = plt.subplots(1,2,figsize=(12,5), constrained_layout=True)
    #d = getContent("Checks/PoissonResultsX5BndFixed.h5")
    d = getContent("Data/PoissonResultsBndFixed.h5")
    x , y = d['positions']
    inside = np.where((x-0.5)**2+(y-0.5)**2 <= 0.4**2)
    outside = np.where((x-0.5)**2+(y-0.5)**2 > 0.4**2)
    ax[0].scatter(x[inside],y[inside],c='k',s=0.1)
    ax[0].scatter(x[outside],y[outside],c='r', s=0.1)
    ax[0].set_xlabel(r"$x$")
    ax[0].set_ylabel(r"$y$")
    checkPoisson("Data/PoissonResults.h5",list(range(10,70)),ax[1])
    #checkPoisson("Checks/PoissonResultsX5.h5",list(range(10,70)),ax[1],funk=lambda x,y : x**5)
    ax[1].lines[-1].set_label('No fixed region')
    checkPoisson("Data/PoissonResultsBndFixed.h5",list(range(10,70)),ax[1])
    #checkPoisson("Checks/PoissonResultsX5BndFixed.h5",list(range(10,70)),ax[1],funk=lambda x,y : x**5)
    ax[1].lines[-1].set_label('Red fixed')
    checkPoisson("Data/PoissonResultsIntFixed.h5",list(range(10,70)),ax[1])
    #checkPoisson("Checks/PoissonResultsX5IntFixed.h5",list(range(10,70)),ax[1],funk=lambda x,y : x**5)
    ax[1].lines[-1].set_label('Black fixed')
    ax[1].grid()
    radius = d['Radiuses']
    thetas = set()
    
    rng = np.random.default_rng(1)
    chosen = rng.choice(len(x),10000)
    for i in chosen:
        xx = x[i]
        yy = y[i]
        r = radius[i]
        r0 = np.sqrt((xx-0.5)**2+(yy-0.5)**2)
        if r0 < 0.39 or r0 > 0.4:
            continue
        theta = np.arctan2(yy-0.5,xx-0.5)
        thetaNorm = int(theta/(2*np.pi)*20)
        if thetaNorm in thetas:
            continue
        thetas.add(thetaNorm)
        
        xlinspace = np.linspace(xx-r+1e-10,xx+r-1e-10,100)
        yup =  yy + np.sqrt(r*r-(xlinspace-xx)**2)
        ydown =  yy - np.sqrt(r*r-(xlinspace-xx)**2)
        ax[0].plot(xlinspace,yup,'tab:purple')
        ax[0].plot(xlinspace,ydown,'tab:purple')
    ax[0].lines[-1].set_label('Stencil radius')
    #ax[0].legend(markerscale=10, fontsize=20, loc="lower center")
    ax[0].set_aspect(1)
    ax[1].set_xlabel(r"$n$")
    ax[1].set_ylabel(r"$e_\mathrm{poiss}^\mathrm{max}$")
    #ax[1].yaxis.set_label_position("right")
    #ax[1].yaxis.tick_right()
    ax[1].legend()
    plt.savefig("../FiguresPaper/BndFixed.png", dpi=dpitoUse, transparent=False, bbox_inches='tight')



    
def plotPoissAndLapMetricContours():
    """Plot the figure displaying our metric"""

    defsize=18
    mpl.rcParams.update({'axes.titlesize' : defsize})
    mpl.rcParams.update({'font.size': defsize})
    mpl.rcParams.update({'xtick.labelsize': defsize})
    mpl.rcParams.update({'legend.fontsize': defsize})
    mpl.rcParams.update({'axes.labelsize': defsize})
    mpl.rcParams.update({'ytick.labelsize': defsize})

    fig = plt.figure(figsize=(10,6), constrained_layout=True)
    gs = fig.add_gridspec(3,6,height_ratios=[2,1,1], width_ratios=[1,1,1,1,1,0.2])
    ax = fig.add_subplot(gs[0,:])
    ax2 = ax.twinx()
    checkPoisson("Data/PoissonResults.h5",list(range(10,70)),ax)
    line = ax.get_lines()[0]
    line.set_color(ccycle[0])
    line.set_label(r"$e_\mathrm{poiss}^\mathrm{max}$")
    line.set_marker("+")
    ax.tick_params(axis='y', which="both",colors=ccycle[0])
    ax.set_xlabel(r"$n$")
    #ax.xaxis.tick_top()
    #ax.xaxis.set_label_position('top') 

    checkPoisson("Data/PoissonResults.h5", list(range(10,70)), ax2, numberMetric=True)
    line = ax2.get_lines()[0]
    line.set_color(ccycle[1])
    #line.set_linestyle("--")
    line.set_label(r"$\delta N_\mathrm{poiss}^\pm$")
    line.set_marker(".")
    
    checkLaplaceErrors("Data/LaplaceOpResults.h5", ax2, numberMetric=True)
    line = ax2.get_lines()[1]
    line.set_color(ccycle[1])
    line.set_label(r"$\delta N_\mathrm{lap}^\pm$")
    line.set_linestyle("--")
    line.set_marker("x")
    #ax2.plot(line.get_xdata(), line.get_ydata(),marker="o")

    ax2.tick_params(axis='y', which="both",colors=ccycle[1])
    #handles, labels = [(a + b) for a, b in zip(ax.get_legend_handles_labels(), ax2.get_legend_handles_labels())]
    ns = [17,27,28,29,34]
    ax2.grid()
    ax2.axhline(y=0,color='green')
    #ax2.axhline(y=0,color='orange')
    ax.grid(axis='x')
    #ax.legend(handles, labels, loc="upper right", fontsize=20)
    ax2.legend(loc="upper right",ncols=2, columnspacing=1, handletextpad=0.1)
    ax.legend(loc=(0.8,0.2), handletextpad=0.1)
    axi = [[],[]]
    color = "viridis"
    for i,n in enumerate(ns):
        axi[0].append(fig.add_subplot(gs[1,i]))
        axi[1].append(fig.add_subplot(gs[2,i]))
    
    for i,n in enumerate(ns):
        plotPoissonErrorContour("Data/PoissonResults.h5", n, axi[0][i], normalise=True, vmin=-1, vmax=1, color=color)
        plotLapErrorContour("Data/LaplaceOpResults.h5",n,axi[1][i], normalise=True, vmin=-1, vmax=1, color=color)
        axi[0][i].set_aspect(1)
        axi[1][i].set_aspect(1)
    for i in range(2):
        for j in range(5):
            axi[i][j].set_xticks([])
            axi[i][j].set_yticks([])
    #axi[0][0].set_ylabel(r"$e_\mathrm{poiss}^\pm$", fontsize=20)
    #axi[1][0].set_ylabel(r"$e_\mathrm{lap}^\pm$", fontsize=20)
        
    ydata = ax.lines[0].get_ydata()
    ydata = [ydata[i-10] for i in ns]
    ax.plot(ns,ydata,"ko")
    for i in range(5):
        addArrow(fig, ax, axi[0][i], [ns[i],ydata[i]], [0.5,1])
    
    axi[0][0].set_ylabel(r"$e^\pm_\mathrm{poiss}$")
    axi[1][0].set_ylabel(r"$e^\pm_\mathrm{lap}$")
    legendax = fig.add_subplot(gs[1:,5])
    #legendax.axis('off')
    
    cmap = plt.get_cmap(color,2)
    cmap = mpl.colors.ListedColormap([cmap(0),cmap(1)])
    bounds = [0,5,10]
    norm = mpl.colors.BoundaryNorm(bounds,cmap.N)
    mpl.colorbar.ColorbarBase(legendax, cmap=cmap, norm=norm, boundaries=bounds, ticks=[2.5,7.5])
    legendax.set_yticklabels([r"$<0$", r"$>0$"])
    legendax.tick_params(axis=u'both', which=u'both',length=0)

    
    """
    patch1 = mpl.patches.Patch(color=plt.get_cmap("viridis")(0.0), label=r"$e_\mathrm{poiss}^\pm < 0$")
    patch2 = mpl.patches.Patch(color=plt.get_cmap("viridis")(1.0), label=r"$e_\mathrm{poiss}^\pm > 0$")
    patch3 = mpl.patches.Patch(color=plt.get_cmap("magma")(0.0), label=r"$e_\mathrm{lap}^\pm < 0$")
    patch4 = mpl.patches.Patch(color=plt.get_cmap("magma")(1.0), label=r"$e_\mathrm{lap}^\pm > 0$")

    legendax.legend(handles=[patch1,patch2, patch3, patch4], fontsize=20, loc="right")
    """
    plt.savefig("../FiguresPaper/MetricContours.png", dpi=dpitoUse, transparent=False, bbox_inches='tight')              

    

     
           
def plotPoissAndLapBothNorms():
    """Plot the first graph showing the minima"""
    mpl.rcParams.update({'font.size': 15})
    mpl.rcParams.update({'xtick.labelsize': 15})
    mpl.rcParams.update({'legend.fontsize': 16})
    mpl.rcParams.update({'axes.labelsize': 16})
    mpl.rcParams.update({'ytick.labelsize': 15})
    
    
    fig, ax = plt.subplots(figsize=(10,4))
    #fig, ax = plt.subplots()
    ax2 = ax.twinx()
    checkPoisson("Data/PoissonResults.h5",list(range(10,70)),ax)
    ax.get_lines()[0].set_color(ccycle[0])
    ax.get_lines()[0].set_label(r"$e_\mathrm{poiss}^\mathrm{max}$")
    checkPoisson("Data/PoissonResults.h5", list(range(10,70)),ax,aggFunk = np.mean)
    ax.lines[-1].set_color(ccycle[0])
    ax.lines[-1].set_linestyle(":")
    ax.lines[-1].set_marker(".")
    ax.lines[-1].set_label(r"$e_\mathrm{poiss}^\mathrm{avg}$")
    
    ax.tick_params(axis='y', which="both",colors=ccycle[0])
    ax.set_xlabel("$n$")

    #ax.set_title("Approximation error dependence on stencil size")
    checkLaplaceErrors("Data/LaplaceOpResults.h5", ax2)
    ax2.get_lines()[0].set_color(ccycle[1])
    ax2.get_lines()[0].set_label(r"$e_\mathrm{lap}^\mathrm{max}$")
    checkLaplaceErrors("Data/LaplaceOpResults.h5",ax2, aggFunk = np.mean)
    ax2.lines[-1].set_color(ccycle[1])
    ax2.lines[-1].set_linestyle(":")
    ax2.lines[-1].set_marker(".")
    ax2.lines[-1].set_label(r"$e_\mathrm{lap}^\mathrm{avg}$")
    ax.grid()
    ax2.tick_params(axis='y', which="both",colors=ccycle[1])
    handles, labels = [(a + b) for a, b in zip(ax.get_legend_handles_labels(), ax2.get_legend_handles_labels())]
    fig.legend(handles, labels, loc = "upper center", ncols=4)
    ax2.set_ylim(1e-3,1e-1)
    
    #This part extracts the info for latex table
    """
    poissmax = ax.lines[0]
    stencilSizes = poissmax.get_xdata()
    emax = poissmax.get_ydata()
    eavg = ax.lines[1].get_ydata()
    lapmax = ax2.lines[0].get_ydata()
    lapavg = ax2.lines[1].get_ydata()
    
    for i in range(len(stencilSizes)):
        currEmax = "{0:.3g}".format(emax[i])
        currEavg = "{0:.3g}".format(eavg[i])
        currlapmax = "{0:.3g}".format(lapmax[i])
        currlapavg = "{0:.3g}".format(lapavg[i])

        print(f"{stencilSizes[i]} & {currEmax} & {currEavg} & {currlapmax} & {currlapavg} \\\\")
        print("\\hline")
    """
    plt.savefig("../FiguresPaper/MeanErrors.png", dpi=dpitoUse, transparent=False,bbox_inches="tight")


def plotMoreDomains():
    defsize=11
    mpl.rcParams.update({'axes.titlesize' : defsize})
    mpl.rcParams.update({'font.size': defsize})
    mpl.rcParams.update({'xtick.labelsize': defsize})
    mpl.rcParams.update({'legend.fontsize': defsize})
    mpl.rcParams.update({'axes.labelsize': defsize})
    mpl.rcParams.update({'ytick.labelsize': defsize})
    fig = plt.figure(figsize=(7,4))
    numx=7
    gs = fig.add_gridspec(5,numx+3, width_ratios=[2] + [1]*(numx+2))
    ax = fig.add_subplot(gs[:3,:2])
    ax2 = fig.add_subplot(gs[3:,:2])
    colorCycle = ccycle
    #names = ['Disc','Square','SquareRotated','Triangle']
    checkPoisson(f"Data/PoissonResultsSeed1.h5",list(range(10,70)),ax)
    ax.lines[-1].set_color("k")
    ax.lines[-1].set_alpha(0.1)
    ax.lines[-1].set_marker("")

    for i in range(5):
        checkPoisson(f"Data/PoissonResultsDomain{i}.h5",list(range(10,70)),ax)
        #ax.lines[-1].set_label(names[i])
        ax.lines[-1].set_marker("")
    ax.set_ylabel(r"$e^\mathrm{max}_\mathrm{poiss}$")
    #ax.grid()

    checkPoisson(f"Data/PoissonResultsSeed1.h5",list(range(10,70)),ax2,numberMetric=True)
    ax2.lines[-1].set_color("k")
    ax2.lines[-1].set_alpha(0.1)
    ax2.lines[-1].set_marker("")

    for i in range(5):
        checkPoisson(f"Data/PoissonResultsDomain{i}.h5",list(range(10,70)),ax2, numberMetric=True)
        ax2.lines[-1].set_marker("")

    ax2.set_xlabel(r"$n$")
    ax2.set_ylabel(r"$\delta N^\pm_\mathrm{poiss}$")

    #ax2.grid()
    #handles, labels = ax.get_legend_handles_labels()
    #legendax.legend(handles, labels)
    #legendax.axis('off')
    ax.fill_between(x=[24,24+numx],y1=1e-7,y2=1e-3,color='k',alpha=0.1)
    ax.get_xaxis().set_ticks([])
    ax2.fill_between(x=[24,24+numx],y1=-1.05,y2=1.05,color='k',alpha=0.1)
    ax.set_ylim(1e-6,1e-3)
    ax2.set_ylim(-1.05,1.05)
    for i in range(5):
        solax = fig.add_subplot(gs[i,2])
        plotSolutionSpecific(f"Data/PoissonResultsDomain{i}.h5",f,solax)
        solax.set_aspect(1)
        solax.get_xaxis().set_ticks([])
        solax.get_yaxis().set_ticks([])
        
        
        if i==0:
            solax.set_title(r"$u(x,y)$")
        for side in solax.spines:
            solax.spines[side].set_color(colorCycle[i])
    ns = [list(range(24,24+numx)) for i in range(5)]
    for i in range(5):
        #ydata = ax.lines[i].get_ydata()
        #ydata = [ydata[j-10] for j in ns[i]]
        #ax.plot(ns[i],ydata,"o",color=colorCycle[i])
        vmin=100
        vmax=-100
        for j in range(numx):
            vmin2,vmax2 = obtainErrorBounds(f"Data/PoissonResultsDomain{i}.h5",ns[i][j],funk=f)
            vmin = min(vmin,vmin2)
            vmax = max(vmax,vmax2)
        for j in range(numx):
            newax = fig.add_subplot(gs[i,3+j])
            plotPoissonErrorContour(f"Data/PoissonResultsDomain{i}.h5",ns[i][j],newax, funk=f,vmin=vmin, vmax=vmax)
            newax.set_aspect(1)
            newax.get_xaxis().set_ticks([])
            newax.get_yaxis().set_ticks([])
            for side in newax.spines:
                newax.spines[side].set_color(colorCycle[i])
            #newax.text(1,1,f"$n={ns[i][j]}$")
            if i==0:
                newax.set_title(f"$n={ns[i][j]}$")
    plt.subplots_adjust(wspace=0.2, hspace=0.1)
    plt.savefig("../FiguresPaper/DifferentDomains.png",bbox_inches='tight',dpi=dpitoUse)
    #plt.savefig("../FiguresPaper/MoreFunctions.png", bbox_inches='tight')

def franke(x,y):
    term1 = 3/4*np.exp(-(9*x-2)**2/4 - (9*y-2)**2/4)
    term2 = 3/4*np.exp(-(9*x+1)**2/49 - (9*y+1)/10)
    term3 = 0.5*np.exp(-(9*x-7)**2/4-(9*y-3)**2/4)
    term4 = -0.2*np.exp(-(9*x-4)**2-(9*y-7)**2)
    return term1+term2+term3+term4


#x^4 y^5 sin(pi x) cos(pi x) cos(pi y)  Bayona atan franke arcsinh exp(r^2)
def plotMoreFunctions():
    defsize=10
    mpl.rcParams.update({'axes.titlesize' : defsize})
    mpl.rcParams.update({'font.size': defsize})
    mpl.rcParams.update({'xtick.labelsize': defsize})
    mpl.rcParams.update({'legend.fontsize': defsize})
    mpl.rcParams.update({'axes.labelsize': defsize})
    mpl.rcParams.update({'ytick.labelsize': defsize})
    fig = plt.figure(figsize=(6,4))
    numx=7
    gs = fig.add_gridspec(7,numx+3, width_ratios=[2] + [1]*(numx+2))
    ax = fig.add_subplot(gs[:3,:2])
    ax.set_yticks([1e-7,1e-6,1e-4])
    ax2 = fig.add_subplot(gs[3:,:2])
    legendax = fig.add_subplot(gs[6,2:])
    colorCycle = plt.rcParams['axes.prop_cycle'].by_key()['color']
    names = [r'$u_1$','$u_2$', '$u_3$','$u_4$','$u_5$','$u_6$']
    filenames = ['x4y5','bayona','expX','asinh','cosxcosy','franke']
    funks = [lambda x ,y : x**4 * y**5, lambda x,y : 1+np.sin(4*x)+np.cos(3*x)+np.sin(2*y), lambda x,y : np.exp(x*x), lambda x,y : np.arcsinh(x+2*y), lambda x,y : np.cos(np.pi*x)*np.cos(np.pi*y), franke]
    #funks = funks[-3:]
    #filenames = filenames[-3:]
    #names = names[-3:]
    checkPoisson(f"Data/PoissonResultsSeed1.h5",list(range(10,70)),ax)
    ax.lines[-1].set_color("k")
    ax.lines[-1].set_alpha(0.1)
    ax.lines[-1].set_marker("")

    for i in range(6):
        checkPoisson(f"Data/PoissonResultsFunc{filenames[i]}.h5",list(range(10,70)),ax, funk=funks[i])
        ax.lines[-1].set_label(names[i])
        ax.lines[-1].set_marker("")
        if i>=3:
            ax.lines[-1].set_linestyle(":")
    ax.set_ylabel(r"$e^\mathrm{max}_\mathrm{poiss}$")


    checkPoisson(f"Data/PoissonResultsSeed1.h5",list(range(10,70)),ax2, numberMetric=True)
    ax2.lines[-1].set_color("k")
    ax2.lines[-1].set_alpha(0.1)
    ax2.lines[-1].set_marker("")

    for i in range(6):
        checkPoisson(f"Data/PoissonResultsFunc{filenames[i]}.h5",list(range(10,70)),ax2, funk=funks[i],numberMetric=True)
        ax2.lines[-1].set_marker("")
        if i>=3:
            ax2.lines[-1].set_linestyle(":")
    ax2.set_ylabel(r"$\delta N^\pm_\mathrm{poiss}$")
    #ax.legend()
    handles, labels = ax.get_legend_handles_labels()
    #ax[0].legend(loc="upper right", ncols=1, columnspacing=1, handlelength=1, handletextpad=0.1)
    legendax.legend(handles, labels, loc="center", ncols=6, handletextpad=0.2, columnspacing=0.75, handlelength=1)
    legendax.axis('off')
    startCheck = 24
    ax.set_ylim(1e-8,5e-3)
    ax.fill_between(x=[startCheck,startCheck+numx],y1=1e-8,y2=5e-3,color='k',alpha=0.1)
    ax.get_xaxis().set_ticks([])
    ax2.fill_between(x=[startCheck,startCheck+numx],y1=-1.05,y2=1.05,color='k',alpha=0.1)
    #ax.set_ylim(1e-7,1e-2)
    ax2.set_ylim(-1.05,1.05)
    ax2.set_xlabel(r"$n$")
    for i in range(6):
        solax = fig.add_subplot(gs[i,2])
        plotSolutionSpecific(f"Data/PoissonResultsFunc{filenames[i]}.h5",funks[i],solax)
        solax.set_aspect(1)
        solax.get_xaxis().set_ticks([])
        solax.get_yaxis().set_ticks([])
        if i==0:
            solax.set_title(r"$u(x,y)$")
        for side in solax.spines:
            solax.spines[side].set_color(colorCycle[i])
            if i>=3:
                solax.spines[side].set_linestyle(":")
    ns = [list(range(startCheck,startCheck+numx)) for i in range(6)]
    for i in range(6):
        #ydata = ax.lines[i].get_ydata()
        #ydata = [ydata[j-10] for j in ns[i]]
        #ax.plot(ns[i],ydata,"o",color=colorCycle[i])
        vmin=100
        vmax=-100
        for j in range(numx):
            vmin2,vmax2 = obtainErrorBounds(f"Data/PoissonResultsFunc{filenames[i]}.h5",ns[i][j],funk=funks[i])
            vmin = min(vmin,vmin2)
            vmax = max(vmax,vmax2)
        for j in range(numx):
            newax = fig.add_subplot(gs[i,3+j])
            plotPoissonErrorContour(f"Data/PoissonResultsFunc{filenames[i]}.h5",ns[i][j],newax, funk=funks[i],vmin=vmin, vmax=vmax)
            newax.set_aspect(1)
            newax.get_xaxis().set_ticks([])
            newax.get_yaxis().set_ticks([])
            for side in newax.spines:
                newax.spines[side].set_color(colorCycle[i])
                if i>=3:
                    newax.spines[side].set_linestyle(":")
            #newax.text(1,1,f"$n={ns[i][j]}$")
            if i==0:
                newax.set_title(f"$n={ns[i][j]}$")
    #plt.savefig("Functions.png",bbox_inches='tight')
    plt.subplots_adjust(wspace=0.1, hspace=0.1)
    plt.savefig("../FiguresPaper/DifferentFunctions.png", bbox_inches='tight',dpi=dpitoUse)


def getFillDist(x,y):
    pos = np.array([x,y])
    pos = pos.T
    pos = pos[(pos[:,0]-0.5)**2 + (pos[:,1]-0.5)**2 < (0.5**2-1e-8)]
    pos = pos.T
    kdtree = spatial.KDTree(pos.T)
    voronoi = spatial.Voronoi(pos.T)
    voronoiPos = voronoi.vertices
    voronoiPos = voronoiPos[(voronoiPos[:,0]-0.5)**2+(voronoiPos[:,1]-0.5)**2 <= 0.5**2]
    voronoiPos = voronoiPos.T
    s = kdtree.query(voronoiPos.T, 1)[0]
    s = 2*np.amax(s)
    spacing = np.amin(kdtree.query(pos.T,2)[0][:,1])
    #s = 2*s
    return np.ones(10)*s/spacing
    #return [np.amin(s),np.amax(s)]

def plotSeeds():

    defsize=20
    mpl.rcParams.update({'axes.titlesize' : defsize})
    mpl.rcParams.update({'font.size': defsize})
    mpl.rcParams.update({'xtick.labelsize': defsize})
    mpl.rcParams.update({'legend.fontsize': defsize})
    mpl.rcParams.update({'axes.labelsize': defsize})
    mpl.rcParams.update({'ytick.labelsize': defsize})
    
    supports = list(range(10,70))
    fig, ax = plt.subplots(1,3,constrained_layout=True, figsize=(12,4))
    mini = np.inf*np.ones(60)
    maxi = -np.inf*np.ones(60)
    miniMetric = np.inf
    maxiMetric = -np.inf
    values = np.array([])
    for i in range(10):
        checkPoisson(f"Data/PoissonResultsSeed{i}.h5",supports,ax[0])
        ydata = ax[0].lines[-1].get_ydata()
        mini = np.minimum(mini,ydata)
        maxi = np.maximum(maxi,ydata)
        x,y = getContent(f"Data/PoissonResultsSeed{i}.h5")['positions']
        values = np.concatenate((values,getFillDist(x,y)))

    miniMetric = np.quantile(values,0)
    maxiMetric = np.quantile(values,1)


    ax[0].clear()
    
    line1 = ax[0].fill_between(supports,mini,maxi, color=ccycle[0], alpha=0.3, label=r"$e^\mathrm{max}_\mathrm{poiss}$")
    ax[0].plot(supports,mini,color=ccycle[0],ls="--")
    ax[0].plot(supports,maxi,color=ccycle[0], ls="--")
    ax[0].grid()
    ax[0].set_yscale("log")
    ax[0].set_xlabel(r"$n$")
    ax[0].tick_params(axis='y', labelcolor=ccycle[0])
    
    ax[0].set_title("Fill algorithm")
    ax[0].set_ylim(4e-6,5e-3)
    
    ax2 = ax[0].twinx()
    ax2.fill_between(supports,np.ones(60)*miniMetric,np.ones(60)*maxiMetric,color=ccycle[2],alpha=0.3)
    ax2.plot(supports,np.ones(60)*miniMetric,color=ccycle[2],ls="--")
    ax2.plot(supports,np.ones(60)*maxiMetric,color=ccycle[2],ls="--")
    ax2.set_ylim(1,30)
    ax2.set_yscale("log")
    ax2.yaxis.set_ticklabels([])
    ax2.yaxis.set_ticks_position('none')


    mini = np.inf*np.ones(59)
    maxi = -np.inf*np.ones(59)
    miniMetric = np.inf
    maxiMetric = -np.inf
    values = np.array([])
    supports = list(range(11,70))
    for i in range(10):
        checkPoisson(f"Data/PoissonResultsUniformSeed{i}.h5",supports,ax[1])
        ydata = ax[1].lines[-1].get_ydata()
        mini = np.minimum(mini,ydata)
        maxi = np.maximum(maxi,ydata)
        x,y = getContent(f"Data/PoissonResultsUniformSeed{i}.h5")['positions']
        values = np.concatenate((values,getFillDist(x,y)))

    miniMetric = np.quantile(values,0)
    maxiMetric = np.quantile(values,1)
 

    ax[1].clear()
    line1 = ax[1].fill_between(supports,mini,maxi, color=ccycle[0], alpha=0.3, label=r"$e^\mathrm{max}_\mathrm{poiss}$")
    ax[1].plot(supports,mini,color=ccycle[0],ls="--")
    ax[1].plot(supports,maxi,color=ccycle[0], ls="--")
    ax[1].grid()
    ax[1].set_xlabel(r"$n$")
    ax[1].set_yscale("log")
    ax[1].set_ylim(ax[0].get_ylim())
    ax[1].yaxis.set_ticklabels([])
    ax[1].yaxis.set_ticks_position('none')
    
    ax2 = ax[1].twinx()
    line2 = ax2.fill_between(supports,np.ones(59)*miniMetric,np.ones(59)*maxiMetric,color=ccycle[2],alpha=0.3)
    ax2.plot(supports,np.ones(59)*miniMetric,color=ccycle[2],ls="--")
    ax2.plot(supports,np.ones(59)*maxiMetric,color=ccycle[2],ls="--")
    ax2.set_ylim(1,30)
    ax2.set_yscale("log")
    ax2.yaxis.set_ticklabels([])
    ax2.yaxis.set_ticks_position('none')
    
    ax[1].legend([line1,line2],[r"$e^\mathrm{max}_\mathrm{poiss}$",r"$\gamma$"],ncols=2)
    ax[1].set_title("Uniform discretisation")

    supports = list(range(10,70))
    mini = np.inf*np.ones(60)
    maxi = -np.inf*np.ones(60)
    miniMetric = np.inf
    maxiMetric = -np.inf
    values = np.array([])
    for i in range(10):
        checkPoisson(f"Data/PoissonResultsHaltonSeed{i}.h5",supports,ax[2])
        ydata = ax[2].lines[-1].get_ydata()
        mini = np.minimum(mini,ydata)
        maxi = np.maximum(maxi,ydata)
        x,y = getContent(f"Data/PoissonResultsHaltonSeed{i}.h5")['positions']
        values = np.concatenate((values,getFillDist(x,y)))

    miniMetric = np.quantile(values,0)
    maxiMetric = np.quantile(values,1)
 
    ax[2].clear()
    line1 = ax[2].fill_between(supports,mini,maxi, color=ccycle[0], alpha=0.3, label=r"$e^\mathrm{max}_\mathrm{poiss}$")
    ax[2].plot(supports,mini,color=ccycle[0],ls="--")
    ax[2].plot(supports,maxi,color=ccycle[0], ls="--")
    ax[2].grid()
    ax[2].set_xlabel(r"$n$")
    ax[2].set_yscale("log")
    ax[2].set_ylim(ax[0].get_ylim())
    ax[2].yaxis.set_ticklabels([])
    ax[2].yaxis.set_ticks_position('none')
    
    ax2 = ax[2].twinx()
    ax2.fill_between(supports,np.ones(60)*miniMetric,np.ones(60)*maxiMetric,color=ccycle[2],alpha=0.3)
    ax2.plot(supports,np.ones(60)*miniMetric,color=ccycle[2],ls="--")
    ax2.plot(supports,np.ones(60)*maxiMetric,color=ccycle[2],ls="--")
    ax2.tick_params(axis='y', labelcolor=ccycle[2])
    ax2.set_ylim(1,30)
    ax2.set_yscale("log")




    ax[2].set_title("Halton nodes")
    plt.savefig("../FiguresPaper/DifferentSeeds.png",bbox_inches='tight',dpi=dpitoUse)

# def plotSeedsOld():
#     #With pointwise behaviour
#     supports = list(range(10,70))
#     fig, ax = plt.subplots(1,3,constrained_layout=True, figsize=(12,4))
#     mini = np.inf*np.ones(60)
#     maxi = -np.inf*np.ones(60)
#     miniMetric = mini
#     maxiMetric = maxi
#     for i in range(50):
#         checkPoisson(f"Data/PoissonResultsSeed{i}.h5",supports,ax[0])
#         ydata = ax[0].lines[-1].get_ydata()
#         mini = np.minimum(mini,ydata)
#         maxi = np.maximum(maxi,ydata)
#         checkPoisson(f"Data/PoissonResultsSeed{i}.h5",supports,ax[0],numberMetric=True)
#         ydata = ax[0].lines[-1].get_ydata()
#         miniMetric = np.minimum(miniMetric,ydata)
#         maxiMetric = np.maximum(maxiMetric,ydata)
        
#     ax[0].clear()
    
#     line1 = ax[0].fill_between(supports,mini,maxi, color='blue', alpha=0.3, label=r"$e^\mathrm{max}_\mathrm{poiss}$")
#     ax[0].plot(supports,mini,color='blue',ls="--")
#     ax[0].plot(supports,maxi,color='blue', ls="--")
#     ax[0].grid()
#     ax[0].set_yscale("log")
#     ax[0].set_xlabel(r"$n$")
#     ax[0].tick_params(axis='y', labelcolor='blue')
    
#     ax2 = ax[0].twinx()
#     line2 = ax2.fill_between(supports,miniMetric,maxiMetric, color='red', alpha=0.3, label=r"$N^\pm_\mathrm{poiss}$")
#     ax2.plot(supports,miniMetric,color='red',ls="--")
#     ax2.plot(supports,maxiMetric,color='red', ls="--")
#     ax2.set_yticks([])
#     #ax.legend([line1,line2],[r"$e^\mathrm{max}_\mathrm{poiss}$",r"$N^\pm_\mathrm{poiss}$"])
#     ax[0].set_title("Behaviour over 50 different seeds in our fill algorithm")
   
#     checkPoisson(f"Data/PoissonResultsUniform.h5",supports,ax[1])
#     ydata = ax[1].lines[-1].get_ydata()
#     mini = ydata
#     checkPoisson(f"Data/PoissonResultsUniform.h5",supports,ax[1],numberMetric=True)
#     ydata = ax[1].lines[-1].get_ydata()
#     miniMetric = ydata        
#     ax[1].clear()
#     line1 = ax[1].fill_between(supports,mini,mini, color='blue', alpha=0.3, label=r"$e^\mathrm{max}_\mathrm{poiss}$")
#     ax[1].plot(supports,mini,color='blue',ls="--")
#     ax[1].grid()
#     ax[1].set_xlabel(r"$n$")
#     ax[1].set_yscale("log")
#     ax[1].set_yticks([])
#     #ax[0].tick_params(axis='y', labelcolor='blue')
    
#     ax2 = ax[1].twinx()
#     line2 = ax2.fill_between(supports,miniMetric,miniMetric, color='red', alpha=0.3, label=r"$N^\pm_\mathrm{poiss}$")
#     ax2.plot(supports,miniMetric,color='red',ls="--")
#     ax2.set_yticks([])
#     ax[1].legend([line1,line2],[r"$e^\mathrm{max}_\mathrm{poiss}$",r"$N^\pm_\mathrm{poiss}$"])
#     ax[1].set_title("Behaviour on a uniformly discretised disc")
#     ax[1].set_ylim(ax[0].get_ylim())

#     mini = np.inf*np.ones(60)
#     maxi = -np.inf*np.ones(60)
#     miniMetric = mini
#     maxiMetric = maxi
#     for i in range(10):
#         checkPoisson(f"Data/PoissonResultsHaltonSeed{i}.h5",supports,ax[2])
#         ydata = ax[2].lines[-1].get_ydata()
#         mini = np.minimum(mini,ydata)
#         maxi = np.maximum(maxi,ydata)
#         checkPoisson(f"Data/PoissonResultsHaltonSeed{i}.h5",supports,ax[2],numberMetric=True)
#         ydata = ax[2].lines[-1].get_ydata()
#         miniMetric = np.minimum(miniMetric,ydata)
#         maxiMetric = np.maximum(maxiMetric,ydata)
        
#     ax[2].clear()
    
#     line1 = ax[2].fill_between(supports,mini,maxi, color='blue', alpha=0.3, label=r"$e^\mathrm{max}_\mathrm{poiss}$")
#     ax[2].plot(supports,mini,color='blue',ls="--")
#     ax[2].plot(supports,maxi,color='blue', ls="--")
#     ax[2].grid()
#     ax[2].set_xlabel(r"$n$")
#     #ax[2].tick_params(axis='y', labelcolor='blue')
#     ax[2].set_yscale("log")
#     ax[2].set_ylim(ax[0].get_ylim())
#     ax[2].set_yticks([])

#     ax2 = ax[2].twinx()
#     line2 = ax2.fill_between(supports,miniMetric,maxiMetric, color='red', alpha=0.3, label=r"$N^\pm_\mathrm{poiss}$")
#     ax2.plot(supports,miniMetric,color='red',ls="--")
#     ax2.plot(supports,maxiMetric,color='red', ls="--")
#     ax2.tick_params(axis='y',labelcolor='red')
#     ax[2].set_title("Behaviour over 10 different Halton discretisations")
#     plt.savefig("../FiguresPaper/DifferentSeeds.png",bbox_inches='tight')

def plotMoreDimensions(mixed=False):
    defsize=14
    mpl.rcParams.update({'axes.titlesize' : defsize})
    mpl.rcParams.update({'font.size': defsize})
    mpl.rcParams.update({'xtick.labelsize': defsize})
    mpl.rcParams.update({'legend.fontsize': defsize})
    mpl.rcParams.update({'axes.labelsize': defsize})
    mpl.rcParams.update({'ytick.labelsize': defsize})
    fig, ax = plt.subplots(1,3,figsize=(8,4),constrained_layout=True)
    if mixed:
        d = getContent('Data/PoissonResultsMixed1DSeed1.h5')
    else:
        d = getContent('Data/PoissonResults1DSeed1.h5')
    x = d['positions']
    real = [np.sin(np.pi*xx) for xx in x]
    ghostNodes = (x < 0-1e-8)
    absErrors = []
    metrics = []
    supports = list(range(4,4+30))
    ax2 = ax[0].twinx()
    for n in supports:
        u = d[f'SolutionN{n}']
        masked = np.ma.masked_array(np.abs(real-u),mask=ghostNodes)
        absErrors.append(np.amax(masked))
        masked2 = np.ma.masked_array(u-real,mask=ghostNodes)
        numPlus = len((masked2)[masked2 > 0])
        numMinus = len((masked2)[masked2 < 0])
        metrics.append((numPlus-numMinus)/(numPlus+numMinus))
    ax[0].plot(supports,absErrors,color=ccycle[0],label=r"1D")
    ax2.plot(supports,metrics,color=ccycle[1])
    ax[0].set_yscale("log")
    ax[0].set_title("1D")
    ax[0].grid()
    ax[0].set_xlabel(r"$n$")
    ax[0].set_ylabel(r"$e^\mathrm{max}_\mathrm{poiss}$", color=ccycle[0])
    ax[0].tick_params(axis='y', labelcolor=ccycle[0])

    ax2.yaxis.set_ticklabels([])
    ax2.yaxis.set_ticks_position('none') 
    ax2.set_ylim(-1.05,1.05)
    if mixed:
        d = getContent('Data/PoissonResultsMixed2DSeed1.h5')
    else:
        d = getContent('Data/PoissonResults2DSeed1.h5')    
    x,y = d['positions']
    real = [np.sin(np.pi*xx)*np.sin(np.pi*yy) for xx,yy in zip(x,y)]
    ghostNodes = ((x-0.5)**2+(y-0.5)**2 > 0.5**2+1e-6)
    absErrors = []
    metrics = []
    ax2 = ax[1].twinx()
    supports = list(range(10,10+190))
    for n in supports:
        u = d[f'SolutionN{n}']
        masked = np.ma.masked_array(np.abs(real-u),mask=ghostNodes)
        absErrors.append(np.amax(masked))
        masked2 = np.ma.masked_array(u-real,mask=ghostNodes)
        numPlus = len((masked2)[masked2 > 0])
        numMinus = len((masked2)[masked2 < 0])
        metrics.append((numPlus-numMinus)/(numPlus+numMinus))
    ax[1].plot(supports,absErrors,color=ccycle[0],label="$23$")
    ax2.plot(supports,metrics,color=ccycle[1])
    ax[1].grid()
    ax[1].set_title("2D")
    ax[1].set_xlabel(r"$n$")
    ax[1].set_yscale("log")
    ax[1].yaxis.set_ticklabels([])
    ax[1].yaxis.set_ticks_position('none') 
    ax2.yaxis.set_ticklabels([])
    ax2.yaxis.set_ticks_position('none') 
    ax2.set_ylim(-1.05,1.05)

    if mixed:
        d = getContent('Data/PoissonResultsMixed3DSeed1.h5')
    else:
        d = getContent('Data/PoissonResults3DSeed1.h5')
    x,y,z = d['positions']
    real = [np.sin(np.pi*xx)*np.sin(np.pi*yy)*np.sin(np.pi*zz) for xx,yy,zz in zip(x,y,z)]
    ghostNodes = ((x-0.5)**2+(y-0.5)**2 + (z-0.5)**2 > 0.5**2+1e-6)
    absErrors = []
    metrics = []
    ax2 = ax[2].twinx()
    supports = list(range(20,20+180))
    for n in supports:
        u = d[f'SolutionN{n}']
        masked = np.ma.masked_array(np.abs(real-u),mask=ghostNodes)
        absErrors.append(np.amax(masked))
        masked2 = np.ma.masked_array(u-real,mask=ghostNodes)
        numPlus = len((masked2)[masked2 > 0])
        numMinus = len((masked2)[masked2 < 0])
        metrics.append((numPlus-numMinus)/(numPlus+numMinus))
    ax[2].plot(supports,absErrors,color=ccycle[0])
    ax[2].set_title("3D")
    ax[2].grid()
    ax[2].set_yscale("log")
    ax[2].set_xlabel(r"$n$")
    ax[2].yaxis.set_ticklabels([])
    ax[2].yaxis.set_ticks_position('none') 
    ax2.plot(supports,metrics,color=ccycle[1])
    ax2.tick_params(axis='y', labelcolor=ccycle[1])
    ax2.set_ylim(-1.05,1.05)

    ax2.set_ylabel(r"$\delta N^\pm_\mathrm{poiss}$", color=ccycle[1])
    
    for i in range(3):
        ax[i].set_ylim(1e-6,1e-1)
    if mixed:
        plt.savefig("../FiguresPaper/DifferentDimensionsMixed.png", bbox_inches='tight', dpi=dpitoUse)    
    else:
        plt.savefig("../FiguresPaper/DifferentDimensions.png", bbox_inches='tight', dpi=dpitoUse)    
  
def plotMoreEquations():
    defsize=10
    mpl.rcParams.update({'axes.titlesize' : defsize})
    mpl.rcParams.update({'font.size': defsize})
    mpl.rcParams.update({'xtick.labelsize': defsize})
    mpl.rcParams.update({'legend.fontsize': defsize})
    mpl.rcParams.update({'axes.labelsize': defsize})
    mpl.rcParams.update({'ytick.labelsize': defsize})
    

    fig = plt.figure(figsize=(6,3.9))
    numx=5
    gs = fig.add_gridspec(5,numx+2, width_ratios = [1.6]+[1]*(numx+1))
    ax = fig.add_subplot(gs[:3,:2])
    ax2 = fig.add_subplot(gs[3:,:2])
    #legendax = fig.add_subplot(gs[:,2])
    #legendax.axis('off')
    #legendax = fig.add_subplot(gs[5,:2])
    colorCycle = plt.rcParams['axes.prop_cycle'].by_key()['color']
    names = [r"$\mathcal{L}_1$",r"$\mathcal{L}_2$",r"$\mathcal{L}_3$",r"$\mathcal{L}_4$",r"$\mathcal{L}_5$"]
    #names = [r'$\mathcal{L} = \nabla^2 + \partial_x \partial_y$', r'$\mathcal{L} = \nabla^2 + \partial_x + \partial_y$',r'$\mathcal{L} = x \partial_{xx} + y^2 \partial_{yy}$',r"$\mathcal{L} = \nabla^2 + 1$",r"$\mathcal{L} = \nabla^2 + 10$"]
    filenames = ['Mixed','Linear','SpatialDep','Helmholtz','Helmholtz2']

    checkPoisson(f"Data/PoissonResultsSeed1.h5",list(range(10,70)),ax)
    ax.lines[-1].set_color("k")
    ax.lines[-1].set_alpha(0.1)
    ax.lines[-1].set_marker("")

    for i in range(5):
        checkPoisson(f"Data/{filenames[i]}PoissonResultsSeed1.h5",list(range(10,70)),ax)
        ax.lines[-1].set_label(names[i])
        ax.lines[-1].set_marker("")
    ax.set_ylabel(r"$e^\mathrm{max}_\mathrm{poiss}$")
    #legendax = fig.add_subplot(gs[5,3:])
    handles, labels = ax.get_legend_handles_labels()
    fig.legend(bbox_to_anchor=[0.39,0.57],framealpha=1, handlelength=1)
    plt.subplots_adjust(wspace=0.2, hspace=0.2)

    #legendax.legend(handles, labels, ncols=3)
    #legendax.axis('off')

    checkPoisson(f"Data/PoissonResultsSeed1.h5",list(range(10,70)),ax2,numberMetric=True)
    ax2.lines[-1].set_color("k")
    ax2.lines[-1].set_alpha(0.1)
    ax2.lines[-1].set_marker("")

    for i in range(5):
        checkPoisson(f"Data/{filenames[i]}PoissonResultsSeed1.h5",list(range(10,70)),ax2, numberMetric=True)
        ax2.lines[-1].set_marker("")
    ax2.set_ylabel(r"$\delta N^\pm_\mathrm{poiss}$")
    ax2.set_xlabel(r"$n$")
    #ax.legend()
    startCheck = 26
    ax.set_ylim(1e-5,1e-3)
    ax.fill_between(x=[startCheck,startCheck+numx],y1=1e-5,y2=1e-3,color='k',alpha=0.1)
    ax.get_xaxis().set_ticks([])
    ax2.fill_between(x=[startCheck,startCheck+numx],y1=-1.05,y2=1.05,color='k',alpha=0.1)
    #ax.set_ylim(1e-7,1e-2)
    ax2.set_ylim(-1.05,1.05)
    #legendax.legend(handles,labels,handlelength=1,ncols=3, columnspacing=1,handletextpad=0.2)
    #legendax.legend(handles,labels,handletextpad=0.2,labelspacing=3)
    ns = [list(range(startCheck,startCheck+numx)) for i in range(6)]
    for i in range(5):
        #ydata = ax.lines[i].get_ydata()
        #ydata = [ydata[j-10] for j in ns[i]]
        #ax.plot(ns[i],ydata,"o",color=colorCycle[i])
        vmin=100
        vmax=-100
        for j in range(numx):
            vmin2,vmax2 = obtainErrorBounds(f"Data/{filenames[i]}PoissonResultsSeed1.h5",ns[i][j])
            vmin = min(vmin,vmin2)
            vmax = max(vmax,vmax2)
        for j in range(numx):
            newax = fig.add_subplot(gs[i,2+j])
            plotPoissonErrorContour(f"Data/{filenames[i]}PoissonResultsSeed1.h5",ns[i][j],newax,vmin=vmin, vmax=vmax)
            newax.set_aspect(1)
            newax.get_xaxis().set_ticks([])
            newax.get_yaxis().set_ticks([])
            for side in newax.spines:
                newax.spines[side].set_color(colorCycle[i])
            #newax.text(1,1,f"$n={ns[i][j]}$")
            if i==0:
                newax.set_title(f"$n={ns[i][j]}$")
    #plt.savefig("Functions.png",bbox_inches='tight')
    #fig.legend(handles,labels, handlelength=1, borderpad=0.02)
    plt.savefig("../FiguresPaper/DifferentEquations.png", bbox_inches='tight',dpi=dpitoUse)
"""
def plotMoreDegrees():
    fig = plt.figure(figsize=(7,4), constrained_layout=True)
    numx=7
    gs = fig.add_gridspec(6,numx+3, width_ratios=[2] + [1]*(numx+2))
    ax = fig.add_subplot(gs[:3,:2])
    ax2 = fig.add_subplot(gs[3:,:2])
    #legendax = fig.add_subplot(gs[5,:2])
    colorCycle = plt.rcParams['axes.prop_cycle'].by_key()['color']
    names = [f"$m={m}$" for m in range(2,7)]
    filenames = [f"PoissonResultsM{m}.h5" for m in range(2,7)]
    supports = [[int((m+1)*(m+2)/2)+i for i in range(50)] for m in range(2,7)]

    for i in range(5):
        checkPoisson(f"Data/{filenames[i]}",supports[i],ax)
        ax.lines[-1].set_label(names[i])
        ax.lines[-1].set_marker("")
    ax.set_ylabel(r"$e^\mathrm{max}_\mathrm{poiss}$")

    legendax = fig.add_subplot(gs[5,3:])
    handles, labels = ax.get_legend_handles_labels()
    legendax.legend(handles, labels, ncols=2)
    legendax.axis('off')

    for i in range(5):
        checkPoisson(f"Data/{filenames[i]}",supports[i],ax2, numberMetric=True)
        ax2.lines[-1].set_marker("")
    ax2.set_ylabel(r"$\delta N^\pm_\mathrm{poiss}$")
    #ax.legend()
    startCheck = 40
    ax.fill_between(x=[startCheck,startCheck+numx],y1=1e-7,y2=1e-2,color='k',alpha=0.1)
    ax.get_xaxis().set_ticks([])
    ax2.fill_between(x=[startCheck,startCheck+numx],y1=-1.05,y2=1.05,color='k',alpha=0.1)
    #ax.set_ylim(1e-7,1e-2)
    ax2.set_ylim(-1.05,1.05)
    ns = [list(range(startCheck,startCheck+numx)) for i in range(6)]
    for i in range(5):
        #ydata = ax.lines[i].get_ydata()
        #ydata = [ydata[j-10] for j in ns[i]]
        #ax.plot(ns[i],ydata,"o",color=colorCycle[i])
        vmin=100
        vmax=-100
        for j in range(numx):
            vmin2,vmax2 = obtainErrorBounds(f"Data/{filenames[i]}",ns[i][j])
            vmin = min(vmin,vmin2)
            vmax = max(vmax,vmax2)
        for j in range(numx):
            newax = fig.add_subplot(gs[i,2+j])
            plotPoissonErrorContour(f"Data/{filenames[i]}",ns[i][j],newax,vmin=vmin, vmax=vmax)
            newax.set_aspect(1)
            newax.get_xaxis().set_ticks([])
            newax.get_yaxis().set_ticks([])
            for side in newax.spines:
                newax.spines[side].set_color(colorCycle[i])
            #newax.text(1,1,f"$n={ns[i][j]}$")
            if i==0:
                newax.set_title(f"$n={ns[i][j]}$")
    #plt.savefig("Functions.png",bbox_inches='tight')
    plt.savefig("../FiguresPaper/MoreDegrees.png", bbox_inches='tight')
"""

def checkDegrees():
    defsize=11
    mpl.rcParams.update({'axes.titlesize' : defsize})
    mpl.rcParams.update({'font.size': defsize})
    mpl.rcParams.update({'xtick.labelsize': defsize})
    mpl.rcParams.update({'legend.fontsize': defsize})
    mpl.rcParams.update({'axes.labelsize': defsize})
    mpl.rcParams.update({'ytick.labelsize': defsize})
    
    ms = [2,3,4,5]
    fig, ax = plt.subplots(2,2,figsize=(6,4), sharey='row',constrained_layout=True)
    axi = [i for j in ax for i in j]
    for i,m in enumerate(ms):
        start = (m+1)*(m+2)//2
        supports = list(range(start,start+50))
        ks = [3,4,5]
        axi[i].set_title(f"$m={m}$")
        if m>2:
            ks.append(6)
        for j,k in enumerate(ks):
            checkPoisson(f"Data/PoissonResultsk{k}M{m}.h5",supports,axi[i])
            axi[i].lines[-1].set_color(ccycle[j])
            axi[i].lines[-1].set_marker("")
        axi[i].grid()
        #if i%2 != 0:
        #    axi[i].yaxis.set_ticklabels([])
        #    axi[i].yaxis.set_ticks_position('none')
        if i%2 == 0:
            axi[i].set_ylabel(r"$e^\mathrm{max}_\mathrm{poiss}$")
        if m>3 or True:
            axi[i].set_xlabel(r"$n$")
    
    lines = axi[3].lines
    labels = [r"$\phi(r) = r^3$", r"$\phi(r) = r^4 \log(r)$",r"$\phi(r) = r^5$", r"$\phi(r) = r^6 \log(r)$"]
    fig.legend(lines,labels,bbox_to_anchor=[0.96,0.45],framealpha=1, handlelength=1,ncols=4, columnspacing=1)
    """
    axi[0].lines[0].set_label(r"$\phi(r) = r^3$")
    axi[0].legend(loc="lower right")
    axi[1].lines[2].set_label(r"$\phi(r) = r^5$")
    axi[1].legend(loc="lower left")
    axi[2].lines[1].set_label(r"$\phi(r) = r^4 \log(r)$")
    axi[2].legend(loc="upper right")
    axi[3].lines[3].set_label(r"$\phi(r) = r^6 \log(r)$")
    axi[3].legend(loc="upper left")
    """
    #axi[1].legend(ncols=2)
    #fig.legend(bbox_to_anchor=[0.9,0.72],framealpha=1, handlelength=1,ncols=4, columnspacing=1)
    plt.savefig("../FiguresPaper/DifferentDegrees.png", bbox_inches='tight',dpi=dpitoUse)
    #axi[1].legend(ncols=4, bbox_to_anchor = [0.6,0.1])
        
    
def justCheck():
    #Error(n) and contours for some things
    
    filename = "exp"
    #funk = lambda x,y : np.cos(np.pi*x)*np.cos(np.pi*y)
    #funk = franke
    funk = lambda x,y : np.arcsinh(x+2*y)
    funk = lambda x,y: np.exp(x*x+y*y)
    #fig, ax = plt.subplots()
    #checkPoisson(f"Data/PoissonResultsFunc{filename}.h5",list(range(10,70)), ax, funk = funk )
    #č
    
    fig, ax = plt.subplots(5,5, constrained_layout=True)
    axi = [a for i in ax for a in i]
    startN = 20
    for i in range(startN,startN+25):
        plotPoissonErrorContour(f"Data/PoissonResultsFunc{filename}.h5",i,axi[i-startN],funk = funk,normalise=True)
        axi[i-startN].set_title(f"n={i}")


def plotSeeds2():

    defsize=17
    mpl.rcParams.update({'axes.titlesize' : defsize})
    mpl.rcParams.update({'font.size': defsize})
    mpl.rcParams.update({'xtick.labelsize': defsize})
    mpl.rcParams.update({'legend.fontsize': defsize})
    mpl.rcParams.update({'axes.labelsize': defsize})
    mpl.rcParams.update({'ytick.labelsize': defsize})
    
    gammas = []
    fig = plt.figure(figsize=(10,7))
    gs = fig.add_gridspec(2,3)
    ax = fig.add_subplot(gs[1,:])
    ax2 = fig.add_subplot(gs[0,0])
    ax3 = fig.add_subplot(gs[0,1])
    ax4 = fig.add_subplot(gs[0,2])
    
    supports = list(range(10,70))
    mini = np.inf*np.ones(60)
    maxi = -np.inf*np.ones(60)
    values = np.array([])
    for i in range(10):
        checkPoisson(f"Data/PoissonResultsSeed{i}.h5",supports,ax2)
        ydata = ax2.lines[-1].get_ydata()
        mini = np.minimum(mini,ydata)
        maxi = np.maximum(maxi,ydata)
        x,y = getContent(f"Data/PoissonResultsSeed{i}.h5")['positions']
        if i==0:
            values = np.concatenate((values,getFillDist(x,y)))
    gammas.append(round(np.mean(values),2))

    ax.fill_between(supports,mini,maxi, color=ccycle[0], alpha=0.3, label=f"DIVG algorithm, $\\gamma={round(np.mean(values),2)}$")
    ax.plot(supports,mini,color=ccycle[0],ls="--")
    ax.plot(supports,maxi,color=ccycle[0], ls="--")
    ax.grid()
    ax.set_yscale("log")
    ax.set_xlabel(r"$n$")
    ax.set_ylabel(r"$e^\mathrm{max}_\mathrm{poiss}$")
    


    mini = np.inf*np.ones(59)
    maxi = -np.inf*np.ones(59)
    values = np.array([])
    supports = list(range(11,70))
    
    for i in range(10):
        checkPoisson(f"Data/PoissonResultsUniformSeed{i}.h5",supports,ax2)
        ydata = ax2.lines[-1].get_ydata()
        mini = np.minimum(mini,ydata)
        maxi = np.maximum(maxi,ydata)
        x,y = getContent(f"Data/PoissonResultsUniformSeed{i}.h5")['positions']
        if i==0:
            values = np.concatenate((values,getFillDist(x,y)))


    gammas.append(round(np.mean(values),2))
    ax.fill_between(supports,mini,maxi, color=ccycle[1], alpha=0.3, label=f"Uniform discretisation, $\\gamma={round(np.mean(values),2)}$")
    ax.plot(supports,mini,color=ccycle[1],ls="--")
    ax.plot(supports,maxi,color=ccycle[1], ls="--")
    

    supports = list(range(10,70))
    mini = np.inf*np.ones(60)
    maxi = -np.inf*np.ones(60)
    values = np.array([])
    for i in range(10):
        checkPoisson(f"Data/PoissonResultsHaltonSeed{i}.h5",supports,ax2)
        ydata = ax2.lines[-1].get_ydata()
        mini = np.minimum(mini,ydata)
        maxi = np.maximum(maxi,ydata)
        x,y = getContent(f"Data/PoissonResultsHaltonSeed{i}.h5")['positions']
        if i==0:
            values = np.concatenate((values,getFillDist(x,y)))

    gammas.append(round(np.mean(values),2))

    ax.fill_between(supports,mini,maxi, color=ccycle[2], alpha=0.3, label=f"Halton nodes, $\\gamma={round(np.mean(values),2)}$")
    ax.plot(supports,mini,color=ccycle[2],ls="--")
    ax.plot(supports,maxi,color=ccycle[2], ls="--")


    ax2.clear()
    plotSolutionSpecific2("Data/PoissonResultsSeed1.h5",ax2,ccycle[0])
    ax2.set_aspect(1)
    plotSolutionSpecific2("Data/PoissonResultsUniformSeed1.h5", ax3, ccycle[1])
    ax3.set_aspect(1)    
    plotSolutionSpecific2("Data/PoissonResultsHaltonSeed1.h5", ax4, ccycle[2])
    ax4.set_aspect(1)
    
    ax2.set_title(f"Fill algorithm, $\\gamma={gammas[0]}$")
    ax3.set_title(f"Uniform fill, $\\gamma={gammas[1]}$")
    ax4.set_title(f"Halton nodes, $\\gamma={gammas[2]}$")
    ax2.tick_params(left = False, right = False , labelleft = False , 
                labelbottom = False, bottom = False)
    ax3.tick_params(left = False, right = False , labelleft = False , 
                labelbottom = False, bottom = False)
    ax4.tick_params(left = False, right = False , labelleft = False , 
                labelbottom = False, bottom = False)    
    
    plt.subplots_adjust(hspace=0.01)
    plt.savefig("../FiguresPaper/DifferentSeeds.png",bbox_inches='tight',dpi=dpitoUse)

def checkRBFs():
    """Plot the graph showing stencil size dependence for different RBFs"""
    defsize=17
    mpl.rcParams.update({'axes.titlesize' : defsize})
    mpl.rcParams.update({'font.size': defsize})
    mpl.rcParams.update({'xtick.labelsize': defsize})
    mpl.rcParams.update({'legend.fontsize': defsize})
    mpl.rcParams.update({'axes.labelsize': defsize})
    mpl.rcParams.update({'ytick.labelsize': defsize})
    names = {0 : "Gaussian", 1 : "MQ", 2: "IMQ"}

    fig, ax = plt.subplots(1,3,figsize=(10,4),sharey=True)
    ax[0].set_ylabel(r"$e_\mathrm{poiss}^\mathrm{max}$")
    for i in range(3):
        ax[i].set_xlabel("$n$")
        checkPoisson("Data/PoissonResults.h5",list(range(10,70)),ax[i])
        ax[i].get_lines()[0].set_color('k')
        ax[i].get_lines()[0].set_label("Cubic PHS")
        ax[i].set_title(names[i])
        checkPoisson(f"Data/PoissonResultsRBF{i}shape1.h5",list(range(10,70)),ax[i])
        ax[i].get_lines()[-1].set_label(f"$\epsilon = 1$")
        ax[i].get_lines()[-1].set_color(ccycle[0])
        checkPoisson(f"Data/PoissonResultsRBF{i}shape10.h5",list(range(10,70)),ax[i])
        ax[i].get_lines()[-1].set_label(f"$\\epsilon = 0.1$")
        ax[i].get_lines()[-1].set_color(ccycle[1])
        ax[i].grid()
    handles, labels = ax[1].get_legend_handles_labels()
    fig.legend(handles,labels,loc=(0.25,0.15),ncols=3)
    plt.savefig("../FiguresPaper/DifferentRBFs.png", dpi=dpitoUse, transparent=False,bbox_inches="tight")

def plotHeat():
    defsize=20
    mpl.rcParams.update({'axes.titlesize' : defsize})
    mpl.rcParams.update({'font.size': defsize})
    mpl.rcParams.update({'xtick.labelsize': defsize})
    mpl.rcParams.update({'legend.fontsize': defsize})
    mpl.rcParams.update({'axes.labelsize': defsize})
    mpl.rcParams.update({'ytick.labelsize': defsize})
    

    fig = plt.figure(figsize=(12,6))
    gs = fig.add_gridspec(2,2, height_ratios = [15,1])
    d = getContent("Data/HeatSteady80.h5")
    x,y,z = d['positions']
    w = d['Solution']
    ax = fig.add_subplot(gs[0,0],projection='3d') 
    cax = fig.add_subplot(gs[1,0])
    
    """
    def truncate_colormap(cmap, minval=0.0, maxval=1.0, n=100):
        new_cmap = mpl.colors.LinearSegmentedColormap.from_list(
            'trunc({n},{a:.2f},{b:.2f})'.format(n=cmap.name, a=minval, b=maxval),
            cmap(np.linspace(minval, maxval, n)))
        return new_cmap
    mycmap = truncate_colormap(plt.get_cmap("hot"),maxval=0.9)
    """
    mycmap = plt.get_cmap("coolwarm")
    im = ax.scatter(x,y,z,c=w, cmap=mycmap)
    cbar = fig.colorbar(im, cax = cax, orientation="horizontal",label=r"T [$^\circ\mathrm{C}$]")
    #cbar.set_ticks([60+5*i for i in range(5)])
    #cbar.set_ticklabels([f"${60+5*i}$" for i in range(5)])
    
    tmp_planes = ax.zaxis._PLANES 
    ax.zaxis._PLANES = ( tmp_planes[2], tmp_planes[3], 
                     tmp_planes[0], tmp_planes[1], 
                     tmp_planes[4], tmp_planes[5])
    ax.zaxis.set_rotate_label(False)
    ax.set_xlabel(r"x [$\mathrm{cm}$]")
    ax.set_ylabel(r"y [$\mathrm{cm}$]")
    ax.set_zlabel(r"z [$\mathrm{cm}$]", rotation=90)
    ax.yaxis.labelpad=10
    ax.xaxis.labelpad=10
    
    # Get rid of colored axes planes
    # First remove fill
    ax.xaxis.pane.fill = False
    ax.yaxis.pane.fill = False
    ax.zaxis.pane.fill = False
    
    # Now set color to white (or whatever is "invisible")
    ax.xaxis.pane.set_edgecolor('w')
    ax.yaxis.pane.set_edgecolor('w')
    ax.zaxis.pane.set_edgecolor('w')
    ax.set_box_aspect((np.ptp(x), np.ptp(y), np.ptp(z)))

    ax = fig.add_subplot(gs[:,1])
    imexNorm = []
    ns = list(range(40,106))
    ##ns = [n for n in ns if n!=90]
    N = len(getContent(f"Data/HeatSteady40.h5")["IMEX"])
    for n in ns:
        print(n)
        d = getContent(f"Data/HeatSteady{n}.h5")['IMEX']    
        imexNorm.append(np.mean(np.abs(d)))
    ax.plot(ns,imexNorm)
    ax.set_xlabel(r"$n$")
    ax.set_ylabel(r"IMEX")
    ax.grid()
    
    plt.tight_layout()
    #plt.subplots_adjust(left=0.3)
    plt.savefig("../FiguresPaper/HeatTransfer.png",dpi=dpitoUse)
if __name__ == "__main__":

    # ===== Functions used in paper ====
    
    print("Making a discretisation plot (Figure 1)...")
    #plotDiscretisation()
    #plt.clf()
    
    print("Making an error(stencil size) plot, (Figure 2)...")
    #plotPoissAndLapBothNorms()
    #plt.clf()
    
    print("Making a convergence plot (Fig 3)...")
    #plotConvergence()
    #plt.clf()
    
    print("Making a discretisation dependence plot (Fig 4)....")
    #plotSeeds2()
    #plt.clf()
    
    print("Making a Boundary effect plot (Fig 5)...")
    #plotBndFixed()
    #plt.clf()
    
    print("Making a parameter dependence plot (Fig 6)...")
    #checkDegrees()
    #plt.clf()
    
    print("Making a RBF dependence plot (Fig 7)")
    #checkRBFs()
    #plt.clf()
    
    print("Making a contours plot (Fig 8)...")
    #plotGraphAndContours()
    #plt.clf()
    
    print("Making a metric plot (Fig 9)...")
    #plotPoissAndLapMetricContours()
    #plt.clf()
    
    print("Making a more dimensions plot (Fig 10)...")
    #plotMoreDimensions(True)
    #plt.clf()
    #plotMoreDimensions(False)
    #plt.clf()
    
    print("Making a more equations plot (Fig 11)...")
    #plotMoreEquations()
    #plt.clf()
    
    print("Making a more functions plot (Fig 12)...")
    #plotMoreFunctions()
    #plt.clf()
    
    print("Making a more domains plot (Fig 13)...")
    #plotMoreDomains()
    #plt.clf()

    print("Making a Heat Steady plot")
    plotHeat()
    #plt.clf()
    print("Done!")



    